/*
 *	aiyagari_openmp.cpp
 *  Created by Jose Mustre-del-Rio on 03/12/2015
 *  Copyright 2015.
 *
 */





//
#include <omp.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <iomanip>
#include <math.h>
#include <fstream>
#include <time.h>
#include <string.h>
//#include <mkl.h>
//#include <mkl_lapack.h>
//#include "mersennetwister.h"
//#include "nrutil.h"


///Parameters
const double discrete_toler = 1e-6;
const double distribution_toler = 1e-12 ;
const int distribution_maxiter=20000;




const int discrete_maxiter=5000;



const int maxsd=3;
//const double mu_x=0.0; //mean of indiosyncratic productivity process

const double hbar=double(1)/double(3);// hours worked when employed
const double gamm=0.4; //individual labor supply elasticity...with divisible labor
const double beta0=.9;//discount factor, initial guess for getting r=1% quarterly

//const double r= 0.01;// quarterly interest rate
const double delta=0.08;//depreciation rate
const double alpha=0.36; //capital share intech



//govern how far the local search goes......sometimes need to widen depending on how big disutility of labor is
const int sminus=20;
const int splus=10;

//bounds for assets

const int amin = 0;

//const double amax= 4500;
const double amax= 600;


//sub -bounds for unequally spaced asset grids



const double a0= amin;
const double a1=2.0;
const double a2=10.0;
const double a3=20.0;
const double a4=80.0;
const double a5=200.0;
const double a6=400;
const double a7=500.0;
const double a8=amax;


//coarse-ness of each of these sub-grids


 const double s1=0.001;
 const double s2=0.005;
 const double s3=0.01;
 const double s4=0.02;
 const double s5=0.1;
 const double s6=0.5;
 const double s7=1.0;
 const double s8=1.0;





/*
 const double s1=0.01;
 const double s2=0.02;
 const double s3=0.05;
 const double s4=0.1;
 const double s5=0.5;
 const double s6=1.0;
 const double s7=1.5;
 const double s8=2.0;
*/


/*
 const double s1=0.1;
 const double s2=0.1;
 const double s3=0.2;
 const double s4=0.4;
 const double s5=0.5;
 const double s6=1.0;
 const double s7=2.0;
 const double s8=2.0;
*/


//bounds and coarseness imply the following number of grid pts per sub grid

const int na1 = int( (a1-a0)/s1)  +1 ;
const int na2 = int( (a2-a1)/s2) +na1;
const int na3 = int( (a3-a2)/s3) +na2;
const int na4 = int( (a4-a3)/s4) +na3;
const int na5 = int( (a5-a4)/s5) +na4;
const int na6 = int( (a6-a5)/s6) +na5;
const int na7 = int( (a7-a6)/s7) +na6;
const int na8 = int( (a8-a7)/s8) +na7;
//const int na9 = int( (a9-a8)/s9) +na8;
//const int na10 = int( (a10-a9)/s10) +na9;
/*
 const int na11 = int( (a11-a10)/s11) +na10;
 const int na12 = int( (a12-a11)/s12) +na11;
 const int na13 = int( (a13-a12)/s13) +na12;
 const int na14 = int( (a14-a13)/s14) +na13;
 const int na15 = int( (a15-a14)/s15) +na14;
 */


//total number of grid pts on asset grid
//const int sizeofAssetgrid= na8;

const int sizeofAssetgrid=6000;


//  log idiosyncratic-island productivity grid size
const int sizeofXgrid=51;

const int XA= sizeofXgrid*sizeofAssetgrid;


//Declare class Vss--- Value function in steady state

class Vss{
	
private:
	//define some private variables that only member functions can access
    double r;
	double beta; //current guess of beta
	double sigma_x ;//variance of idiosyncratic prod process
	double rho_x  ;//persistence of idiosyncratic prod process
	double mu_x;
  double wage_ss;
  int zero_index;
    double sig; //intertemporal elasticity of subs 
    
	double *x_ss;//stores invariant distribution over X's
	double *CDF_Xss;
	
    
	double **CDFX_ij;//stores CDF(x_j|x_i)
	
    
    double *mu0;//stores measure of people over AxX
    double *mu1;//stores measure of people over AxX
    double *Fmu;
	double **CDF_mu0;///cdf//stores cumulative measure of people over AxX
    
    
    
    int *xind, *aind;
    
	double *Assetgrid, *Xgrid;//grids over assets and log x prod,
	double **Xprob;//dmatrix that stores transition probabilities between x realizations
    double **Xprobtran;//
	double *betaXprob;//dmatrix that stores transition probabilities between x realizations multiplied by beta
	double *Xprobtranflat;
	int *incomebound;//stores index of a'on A grid, where beyond this a' is infeasible given income, when working
	
	//for splines of EV over asset dimension
	double *EVcond_x;//stores E[V(a',x')|x, e, work] i.e. conditional on x, experience and working today
    
    
    double *V;// stores V(a,x), but in the order: x are rows, a are columns
    double *V1;//new guess of V
	
	double *income; //stores income of working (1+r)a + x , also in order XxA
	
    
    //stores savings choices of each case....note these are indices
    int *savings_index;
    

    
    //aggregate moments of interest
    double Agg_K;//aggregate capital
    int Agg_K_index;//index on discrete grid closest to aggregate capital
    double Agg_C;
  double Agg_L;
    
    
    
    
public:
    //define member functions
	//constructor
	Vss(double bet);
	//destructor
	~Vss();
	
    //evaluate "equilibrium"
    //this function will calculate value functions, policies, and stationary dist of XxA 
	double evaluate_at_beta(double bet,int p);
	
	//does discrete approx do value functions
	void do_discrete_approx();//
	void print_vfandpolicies(int);
	
	void discretize_assetgrid();
	
	void tauchen();	
	void update_EV();
	void get_ss_Xdist();
    
	void get_invariant_distribution();
    
	//updates income matrices and income bounds
	void update_Umats();
	
    
    
    double utility_of_c(double);
    
    double get_implied_r();
    double zbrent( double x1, double x2 , double tol);
    
    void find_eq_beta();
    
    
};//close class declaration Vs



//declarations of some functions
void discret(double x[], int,  double , double);
double max(double [], int,  int&);
double max( double a, double b, int &maxer);
double max( double a, double b);
double max( double [], int b);
double min( double a, double b);
int max( int a, int b);
int min( int a, int b);
double linear_interp( double x[], double y[], int nn, double xtilde);
double linear_interp( double x[], int y[], int nn, double xtilde);


void hpsort(unsigned long n, double ra[]);


void locate(double xx[], int n, double x, int *j);
double cdf_normal(double);

//NR declarations
void nrerror(char error_text[]);
double *dvector(long nl, long nh);
double **dmatrix(long nrl, long nrh, long ncl, long nch);
void free_dvector(double *v, long nl, long nh);
void free_dmatrix(double **m, long nrl, long nrh, long ncl, long nch);
void amoeba(double **p, double y[], int ndim, double ftol,			Vss *vs, int *nfunk);


double correlation( double *y, double *x, int n);
double correlation_logfirst( double *y, double *x, int n);
double correlation_nonzero( double *y, double *x, int n);
double variance( double *y, int n);
double covariance( double *y, double *x, int n);
void  spline(double x[], double y[], int nn, double yp1, double ypn, double y2[]);
double splint(double xa[], double ya[], double y2a[], int nn, double x);



using namespace std;


int main(){


	double iter_time=omp_get_wtime();

	Vss valf(0.981);
    
       valf.evaluate_at_beta(0.93295,0);

	cout<<"process took "<< omp_get_wtime()-iter_time<<"  seconds\n ";
   
   
	return 0;
	
	
	
}//close int main





//Functions used
Vss::Vss(double bet){
    
    /// 4% annual, 1% quarterly
    r=0.04;
	
	//set current guess of beta
	beta=bet;
	
    //get K/L implied by  targeted real interest rate
    double lnKL= ( log(r+delta) -log(alpha)  )/(alpha-1);
    //set  wage rate given this K/L ratio
    wage_ss=exp(  log(1-alpha) + (alpha)*lnKL);
    
    mu_x=0.0;
    
    rho_x= 0.94548;
    sigma_x=0.35007;
    sig= 1;
	
    
    
    
    
    cout<<sizeofAssetgrid<<endl;
    //create grids on assets
	Assetgrid=new double[sizeofAssetgrid];
	
     discret(Assetgrid, sizeofAssetgrid,  amin, amax);
    
	//discretize_assetgrid();
    for(int a=0; a<sizeofAssetgrid; a++){
        if ( fabs(Assetgrid[a])<1e-6){zero_index=a;
            a=sizeofAssetgrid;
        }
    }
    
    //get x[xa] and a[xa] arrays
    xind=new int[XA];
    aind=new int[XA];
    
    for(int xa=0;xa<XA;xa++){
        int a= xa%sizeofAssetgrid;
        int x= (xa-a)/sizeofAssetgrid; 
		xind[xa]=x;
		aind[xa]=a;
    
    }
    
    
    
    
    
    
	Xgrid=new double[sizeofXgrid];
    
    CDF_Xss=new double[sizeofXgrid];
    CDFX_ij=new double*[sizeofXgrid];
       for(int x=0; x<sizeofXgrid;x++){
        CDFX_ij[x]=new double[sizeofXgrid];
        for(int xx=0; xx<sizeofXgrid;xx++){
            CDFX_ij[x][xx]=0.0;
        }
    }
    
    
    
	Xgrid = new double[sizeofXgrid];
	Xprob = new double*[sizeofXgrid];
	Xprobtran=new double*[sizeofXgrid];
	betaXprob = new double[sizeofXgrid*sizeofXgrid];
	Xprobtranflat=new double[sizeofXgrid*sizeofXgrid];	

	for (int i=0; i<sizeofXgrid;i++){
		Xgrid[i]=0.0;
		Xprob[i]=new double[sizeofXgrid];
		Xprobtran[i]=new double[sizeofXgrid];

		for (int j=0; j<sizeofXgrid; j++){
			Xprob[i][j]=0.0;
			Xprobtran[i][j]=0.0;
		}
	}
    

    
	//create Xgrid
	tauchen();
	
	
    
	x_ss=new double[sizeofXgrid];
   for (int j=0; j<sizeofXgrid;j++){
		x_ss[j]= 1.0/double(sizeofXgrid);
   }
	
    
	get_ss_Xdist();
    
    
    
    
    //initialize utility matrices
	
	
	income=new double[XA];
	incomebound=new int[XA];
    
    
    V=new double[XA];
    V1=new double[XA];
    
    EVcond_x=new double[XA];
    
    savings_index=new int[XA];
    
    
    mu0=new double[XA];
    mu1=new double[XA];
    Fmu=new double[XA];
    CDF_mu0=new double*[sizeofXgrid];
    
	for(int x=0;x<sizeofXgrid;x++){
		CDF_mu0[x]=new double[sizeofAssetgrid];
		for(int a=0; a<sizeofAssetgrid; a++){
				CDF_mu0[x][a]=0.0;
			}//a
		}//x
       
    
    
        for (int x=0; x<XA;x++){
	     income[x]=0.0;
            incomebound[x]=0;
            
            V[x]=0.0;
            V1[x]=0.0;
            EVcond_x[x]=0.0;         
            savings_index[x]=0;
            
            mu0[x]=0.0;
            mu1[x]=0.0;
            Fmu[x]=0.0;
    }//close x
    
    
	
}//close Vs constructor


//destructor
Vss::~Vss(){
	
	delete[] xind;
	delete[] aind;
	
	
    for(int x=0;x<sizeofXgrid;x++){delete[] Xprob[x];
    								delete[] Xprobtran[x];
    									}
    delete[] Xprob;
	delete[] Xprobtran;
	delete[] betaXprob;
	delete[] Xprobtranflat;

	
	//DE-create grids on assets
	delete[] Assetgrid;
	
	delete[] Xgrid;	
	delete[] x_ss;		
		
	delete[] CDF_Xss;
    	
	for (int i=0;i<sizeofXgrid;i++){
		delete[] CDFX_ij[i];//stores CDF(x_j|x_i)
	}
	delete[] CDFX_ij;
	
    
      
    
    for (int x=0; x<sizeofXgrid;x++){

        delete[] CDF_mu0[x];
    }//close x
    
    delete[] income;
    delete[] incomebound;
    
    delete[] V;
    delete[] V1;
    delete[] EVcond_x;
    
    delete[] savings_index;
    delete[] mu0;
    delete[] mu1;
    delete[] CDF_mu0;
	delete[] Fmu;
   
    
	
    
    
}//close Vs destructor


void Vss::find_eq_beta(){
    
    // find beta which satisfies r=.01 using zbrent's method
	
	double betalow=0.98, betahigh=0.989;
	
	double tol=(1.0e-3)*(betahigh+betalow)/2.0;
	
	double start_time;
	
	start_time = omp_get_wtime();
	update_Umats();
	
	beta = zbrent(  betalow , betahigh, tol);
    cout<<" finding beta took " << omp_get_wtime()-start_time << "seconds \n";
	cout<<" beta is " << beta <<endl;

    
    
}//close find_eq_beta

#define SIGN(a,b) ((b) >= 0.0 ? fabs(a) : -fabs(a))
#define NRANSI
#define ITMAX 100
#define EPS 3.0e-8
double Vss::zbrent( double x1, double x2 , double tol)
{
	int iter=0,i=0;
	double a=x1,b=x2,c=x2,d,e,min1,min2;
	
	
	
	double fa=evaluate_at_beta(a,0);
    double fb=evaluate_at_beta(b,0);
	double fc,p,q,r,s,tol1,xm;
	time_t start_time;
	time_t stop_time;
	
	
	if ((fa > 0.0 && fb > 0.0) || (fa < 0.0 && fb < 0.0))
		cout<< ("Root must be bracketed in zbrent \n");
	fc=fb;
	for (iter=1;iter<=ITMAX;iter++) {
		if ((fb > 0.0 && fc > 0.0) || (fb < 0.0 && fc < 0.0)) {
			c=a;
			fc=fa;
			e=d=b-a;
		}
		if (fabs(fc) < fabs(fb)) {
			a=b;
			b=c;
			c=a;
			fa=fb;
			fb=fc;
			fc=fa;
		}
		tol1=2.0*EPS*fabs(b)+0.5*tol;
		xm=0.5*(c-b);
		if (fabs(xm) <= tol1 || fb == 0.0) return b;
		if (fabs(e) >= tol1 && fabs(fa) > fabs(fb)) {
			s=fb/fa;
			if (a == c) {
				p=2.0*xm*s;
				q=1.0-s;
			} else {
				q=fa/fc;
				r=fb/fc;
				p=s*(2.0*xm*q*(q-r)-(b-a)*(r-1.0));
				q=(q-1.0)*(r-1.0)*(s-1.0);
			}
			if (p > 0.0) q = -q;
			p=fabs(p);
			min1=3.0*xm*q-fabs(tol1*q);
			min2=fabs(e*q);
			if (2.0*p < (min1 < min2 ? min1 : min2)) {
				e=d;
				d=p/q;
			} else {
				d=xm;
				e=d;
			}
		} else {
			d=xm;
			e=d;
		}
		a=b;
		fa=fb;
		if (fabs(d) > tol1)
			b += d;
		else
			b += SIGN(tol1,xm);
		fb=evaluate_at_beta(b,1);
		cout<<" iteration " <<iter <<"  in zbrent \n";
		
		
	}
	cout<<(" Maximum number of iterations exceeded in zbrent \n");
	return 0.0;
}
#undef ITMAX
#undef EPS
#undef NRANSI
#undef SIGN



double Vss::evaluate_at_beta(double b,int prev){
	//get value functions, policies and invariant distribution, holding B's and mu's fixed and given beta=b.
	
	
	double out=0.0;
	beta=b;
    
    tauchen();
	get_ss_Xdist();
	
    
       	update_Umats();
	do_discrete_approx(); 
	get_invariant_distribution();
	out=get_implied_r();	
	return out;
}//close evaluate at beta







void Vss::print_vfandpolicies(int cd){
	
	//char name[50];
    
	//int array;
    
	//output data
	ofstream out_file;
	
	
	
	//setting output file stream format
	out_file << setiosflags(ios::fixed)
	<<  setiosflags(ios::showpoint)
	<< setprecision(4);
	////sending data to file
	
    out_file.open("vf.txt");
    
    for (int a=0;a<sizeofAssetgrid;a++){
        out_file<< Assetgrid[a]<<"	 ";
        for (int x=0; x<sizeofXgrid;x++){
                out_file<<V[a+sizeofAssetgrid*x]<<"  ";
                
            
        }//close x
        out_file<<"\n";
    }//a
    
    out_file.close();
    
	
	//setting output file stream format
	out_file << setiosflags(ios::fixed)
	<<  setiosflags(ios::showpoint)
	<< setprecision(8);
	////sending data to file
    out_file.open("pol.txt");
    
    for (int a=0;a<sizeofAssetgrid;a++){
        out_file<< Assetgrid[a]<<" ** ";
        for (int x=0; x<sizeofXgrid;x++){
                
                
                out_file<<Assetgrid[savings_index[a+sizeofAssetgrid*x]]<<"	 ";
            }//close x
        out_file<<"\n";
    }//close a
    
    out_file.close();
    
    
    out_file << setiosflags(ios::fixed)
	<<  setiosflags(ios::showpoint)
	<< setprecision(8);
	////sending data to file
    out_file.open("pdf.txt");
    
    for (int a=0;a<sizeofAssetgrid;a++){
        out_file<< Assetgrid[a]<<"	 ";
        for (int x=0; x<sizeofXgrid;x++){
            out_file<<mu0[a+sizeofAssetgrid*x]<<"  ";       
        }
        out_file<<"\n";
        
    }//close a
    
    out_file.close();
    
	return;
    
	
    
    
    
    
}//close print functions








void Vss::update_Umats(){
	
	
	int x,a;
	cout<<"computing utility matrices \n";
	//calculate upperbound of a' matrices
   #pragma omp parallel for  schedule(static,1) private(x,a)
    for(int xa=0; xa<XA; xa++){
    		x=xind[xa];
    		a=aind[xa];
            income[a+sizeofAssetgrid*x]= (1.00+r)*Assetgrid[a] + wage_ss*exp(Xgrid[x]);
            
            int apr=0;
            while( apr<sizeofAssetgrid & income[a+sizeofAssetgrid*x]>Assetgrid[apr] ){apr++;}
            incomebound[a+sizeofAssetgrid*x]= min(apr-1,sizeofAssetgrid-1);
    }//close xa
    
    
    
    
	
}//close update_Umats()


double Vss:: utility_of_c(double c){
    return log(c);
}


void Vss::do_discrete_approx(){
	
	
    double error=0.0,et=0.0,lagerror=0.0;
    int iter=0;
    

    
    
    double iter_time;
    cout<< " starting discrete approx \n";
    double	start_time = omp_get_wtime();
	#define CHUNKSIZE 1
	
    //do a discrete approx first
    while( iter<discrete_maxiter){ 
        iter_time=omp_get_wtime();
        
        
        
		#pragma omp parallel for schedule(static,1) 
            for( int xa=0; xa<XA; xa++){
                   int a= aind[xa];
                   int x= xind[xa]; 
                    V1[xa]= -1e30;	  
                   
                    int aprmin, aprmax;
                    //set bounds for local search of a' maximizer
                    
                    if (a==0 ){
                        //if lowest asset grid pt, use normal search to start
                        aprmin=0;
                        aprmax=incomebound[xa];
                    }
                    
                    else{
                        //otherwise, use info from savings decision 
                        aprmin=max(0,savings_index[xa]-sminus);
                        aprmax=min(incomebound[xa], savings_index[xa]+splus);
                    }
                    
                    double temp=0;
                    int offset=sizeofAssetgrid*x;
                    
                    //loop over some a'                                        
                    for(int apr=aprmin; apr<=aprmax; apr++){
                        //evaluate vf at this a'
                        
                        temp = log(  income[xa] -Assetgrid[apr])
                               
                        
                        +  EVcond_x[apr+offset];
                        
                        //check if maximizer (so far)
                        if(temp>V1[xa]){
                            
                            V1[xa]=temp;
                            savings_index[xa]=apr;
                        }//clise if
                        	if(apr>aprmin&temp<V1[xa]){apr=aprmax+1;}
                        
                    }//close for loop apr
                    
                    //if upperbound is binding, redo search with full bounds
                    if( (savings_index[xa]==aprmax & aprmax<incomebound[xa])
                    ||   (savings_index[xa]==aprmin & aprmin>0) ) {
                        V1[xa] = -1e30;
                        for(int apr=0; apr<=incomebound[xa]; apr++){
                            //evaluate vf at this a'
                            
                            temp = log(   income[xa] -Assetgrid[apr] )
                        
                            +  EVcond_x[apr+offset];
                            
                            //check if maximizer (so far)
                            if(temp>V1[xa]){
                                
                                V1[xa]=temp;
                                savings_index[xa]=apr;
                            }//clise if
	                            if(apr>0&temp<V1[xa]){apr=incomebound[xa]+1;}
							
                            
                        }//close for loop apr
                        
                    }//close if bounds binding
                    
             }//close x	
        
        	
        
        
        
    		error=0.0;
	#pragma omp parallel for reduction(max : error)
    for( int xa=0;xa<XA; xa++){
       		double et=fabs(V1[xa]-V[xa]);
      		V[xa]=V1[xa]; 
        if(et > error){
            error = et;   
        }//if
     }//for
    
        
    	/*    
        for (int xa=0; xa<XA; xa++){
            	et=fabs( V1[xa]-V[xa] );
                V[xa]=V1[xa];	
                if (et>error){
                   error=et;
                }//close et
        }//xa
        */
        
       
        
        //update 
        
        
        update_EV();			
        cout<<setprecision(7);
	//	cout<<error<<endl;
        if (error< discrete_toler ){
            
            iter=discrete_maxiter+10;
            
        }
        
        if(iter>0 & error>lagerror){
            cout<<"error increased \n";
            iter=discrete_maxiter+10;
        }
        
        
        lagerror=error; 
        if (iter==discrete_maxiter-1){
            cout<<"no convergence from discrete approx \n";
            cout<<"error is "<< error<<endl;}	
        iter++;
        
        
        
        
        
        error=0.0;
        
        
        
        
        
        
        
    }//close iter loop
    
    
    cout<<" vf convergence took "<< omp_get_wtime()-start_time <<"  seconds \n";
    
    
    
    
    return;	
    
}//close do_discrete_approx




void discret(double a[], int arraysize,  double lbar, double ubar)
{
	a[0]=lbar;
	a[arraysize-1]=ubar;
	for (int i=1; i<arraysize-1;i++){
		
		a[i]= a[0] + (ubar-lbar)/arraysize*i;
	}
	
	
	return;
}//end discret




void Vss::tauchen(){
	
	/*
	Xgrid = new double[sizeofXgrid];
	Xprob = new double*[sizeofXgrid];
	Xprobtran=new double*[sizeofXgrid];
	betaXprob = new double*[sizeofXgrid];
	*/
	for (int i=0; i<sizeofXgrid;i++){
		Xgrid[i]=0.0;
		for (int j=0; j<sizeofXgrid; j++){
			Xprob[i][j]=0.0;
			Xprobtran[i][j]=0.0;
		}
	}
	
		for(int xx=0;xx<sizeofXgrid*sizeofXgrid;xx++){
		betaXprob[xx]=0.0;
				Xprobtranflat[xx]=0.0;

		}
	
	
	double a = (1-rho_x)*mu_x;
	
	Xgrid[sizeofXgrid-1] = mu_x + maxsd*sqrt(sigma_x*sigma_x/(1 - rho_x*rho_x));
	Xgrid[0]= mu_x - maxsd*sqrt(sigma_x*sigma_x/(1 - rho_x*rho_x));
	
	double zstep = (Xgrid[sizeofXgrid-1] - Xgrid[0])/(sizeofXgrid-1);
	
	//get values on grid of X
	for (int i=1; i<sizeofXgrid-1; i++){
		Xgrid[i] = Xgrid[0] + zstep*i  ;
	} //close i
	
	//construct transition dmatrix between values of Z (markov dmatrix)
	for(int j=0; j<sizeofXgrid; j++){ 
		for(int k=0; k<sizeofXgrid; k++){
			if (k == 0){
				
				Xprob[j][k] = cdf_normal( ((Xgrid[1]+Xgrid[0])/2.00 -a -rho_x*Xgrid[j]  )/sigma_x );
			}
			else if (k == sizeofXgrid-1){
				Xprob[j][k] = 1 - cdf_normal( ( (Xgrid[sizeofXgrid-1]+Xgrid[sizeofXgrid-2])/2.00 - a - rho_x*Xgrid[j]   )/sigma_x);
				
				
			}
			else{
				Xprob[j][k] = cdf_normal((  (Xgrid[k+1]+Xgrid[k])/2.00 - a -rho_x*Xgrid[j]  )/sigma_x)
				- cdf_normal((  (Xgrid[k]+Xgrid[k-1])/2.00 - a -rho_x*Xgrid[j]  )/sigma_x);
				
				
			} //close else
		}//close k
	}//close j
	
	
	//make sure each row adds up to 1
	double sum=0.0;
	for (int i=0; i<sizeofXgrid; i++){
		for (int j=0; j<sizeofXgrid; j++){
			sum= sum + Xprob[i][j];
		}
		
		for (int j=0; j<sizeofXgrid; j++){
			Xprob[i][j]= Xprob[i][j]/sum;
		}
		sum=0.0;
	}
	
	
	//transpose X
	for(int i=0;i<sizeofXgrid;i++){
		for(int j=0;j<sizeofXgrid;j++){
			Xprobtran[i][j]=Xprob[j][i];
		}
	}
	
	//beta Xprob
		for(int i=0;i<sizeofXgrid;i++){
		for(int j=0;j<sizeofXgrid;j++){
			betaXprob[j+i*sizeofXgrid]=beta*Xprob[i][j];
		}
	}
	
	
	//Xprobtranflat	
	    for(int xpr=0;xpr<sizeofXgrid;xpr++){
    	for(int x=0; x<sizeofXgrid;x++){
    	Xprobtranflat[xpr*sizeofXgrid+x]=Xprobtran[xpr][x];
    	}//x
    }//xpr
	
	
	
	ofstream out_file;
	
	out_file.open("Xmatrix.txt");
	
	if (out_file.fail())
	{
		cout<< " The file was not opened" << endl;
		exit(1);
	}
	
	//setting output file stream format
	out_file << setiosflags(ios::fixed)
	<<  setiosflags(ios::showpoint)
	<< setprecision(5);
	for (int i=0; i<sizeofXgrid;i++){
		for (int j=0; j<sizeofXgrid; j++){
			out_file<< Xprob[i][j]<<"	";
		}
		out_file<<endl;
	}
	
	out_file.close();
    
    
    
    //get CDF(x_j |x_i)
	for (int x=0; x<sizeofXgrid; x++){
		CDFX_ij[x][0]= Xprob[x][0];
		for (int xx=1; xx<sizeofXgrid; xx++){
			CDFX_ij[x][xx] =  CDFX_ij[x][xx-1] + Xprob[x][xx];
		}//close j
	}//close i
    
    
    out_file.open("CDF_Xij.txt");
	
	if (out_file.fail())
	{
		cout<< " The file was not opened" << endl;
		exit(1);
	}
    
    //setting output file stream format
	out_file << setiosflags(ios::fixed)
	<<  setiosflags(ios::showpoint)
	<< setprecision(5);
	for (int i=0; i<sizeofXgrid;i++){
		for (int j=0; j<sizeofXgrid; j++){
			out_file<< CDFX_ij[i][j]<<"	";
		}
		out_file<<endl;
	}
	out_file.close();
    
    
	
	return;
}//close tauchen



void Vss::get_ss_Xdist(){
	
	
	double *xss1= new double[sizeofXgrid];
	double error=0.0;
	double sum=0.0;
	int iter=0;
	while( iter<1000){
		for (int i=0; i<sizeofXgrid;i++){
			xss1[i]=0.0;
			for (int j=0; j<sizeofXgrid; j++){
				xss1[i]= xss1[i] + x_ss[j]*Xprob[j][i];
			}
			
		}//close i loop
        //make sure x_ss adds up to 1
        
        sum=0.0;
        for (int i=0; i<sizeofXgrid;i++){
            sum = sum + xss1[i];
        }
        
        for (int i=0; i<sizeofXgrid;i++){
            xss1[i] = xss1[i]/sum;
            
        }
        
        
        
        
		//check if xss1 and xx0 are close enough
		for (int i=0; i<sizeofXgrid;i++){
			error=max(error,fabs(xss1[i]-x_ss[i]));
			x_ss[i]=xss1[i];
		}
		
		if (error<1e-14){	
			
		    iter=1000;}
		else if(iter==1000){
			cout<<"could not find invariant x dist "<<endl;
		}
		iter++;
		error=0.0;
		
	}//close while		
	
    
	
	
	
	//calculate CDF of x_ss
	CDF_Xss[0]=x_ss[0];
	for (int x=1; x<sizeofXgrid;x++){
		CDF_Xss[x]= CDF_Xss[x-1] + x_ss[x];
	}
	
	
	
	
	
    delete[] xss1;			
    
	
	
	
	
	return;
}//close get_ss_Xdist



void Vss::discretize_assetgrid(){
	
	Assetgrid[0]=amin;
	
	
	for (int i=1; i<na1; i++){
		Assetgrid[i] = Assetgrid[i-1] + s1;
	}
	
	
	for (int i=na1; i<na2; i++){
		Assetgrid[i] = Assetgrid[i-1] + s2;
	}
	
	
	for (int i=na2; i<na3; i++){
		Assetgrid[i] = Assetgrid[i-1] + s3;
	}
	
	for (int i=na3; i<na4; i++){
		Assetgrid[i] = Assetgrid[i-1] + s4;
	}
	
	
	for (int i=na4; i<na5; i++){
		Assetgrid[i] = Assetgrid[i-1] + s5;
	}
	
	
	for (int i=na5; i<na6; i++){
		Assetgrid[i] = Assetgrid[i-1] + s6;
	}
	
	
	for (int i=na6; i<na7; i++){
		Assetgrid[i] = Assetgrid[i-1] + s7;
	}
	
	
	for (int i=na7; i<na8; i++){
		Assetgrid[i]=Assetgrid[i-1] + s8;
	}
     
     
	/*
     
     for (int i=na8; i<na9; i++){
     Assetgrid[i]=Assetgrid[i-1] + s9;
     }
     
     for (int i=na9; i<na10; i++){
     Assetgrid[i]=Assetgrid[i-1] + s10;
     }
     */
	/*
     for (int i=na10; i<na11; i++){
     Assetgrid[i]=Assetgrid[i-1] + s11;
     }
     
     for (int i=na11; i<na12; i++){
     Assetgrid[i]=Assetgrid[i-1] + s12;
     }
     
     for (int i=na12; i<na13; i++){
     Assetgrid[i]=Assetgrid[i-1] + s13;
     }
     
     
     for (int i=na13; i<na14; i++){
     Assetgrid[i]=Assetgrid[i-1] + s14;
     }
     
     
     for (int i=na14; i<na15; i++){
     Assetgrid[i]=Assetgrid[i-1] + s15;
     }
     
     
     */
	
	
	return;
	
}//close discretize_assetgrid

void Vss::update_EV(){
    
	
	
	
	//calculate conditional EV
	#pragma omp parallel for  schedule(static,1)
		  for(int  xa=0; xa<XA; xa++){
		           int a= aind[xa];
                   int x= xind[xa];
                   int offset=sizeofXgrid*x; 
		   	   			  EVcond_x[xa]=0.0;
    						for (int xpr=0;xpr<sizeofXgrid; xpr++){
						EVcond_x[xa] += V[a+sizeofAssetgrid*xpr]*betaXprob[xpr+offset];
					}//close xprime
       		}//x 
    
    
        
	return;
	
	
}//close update_EV


void Vss::get_invariant_distribution(){
    
    cout<<"calculating invariant distribution \n";
    double error=1,errortemp=0.0, sum=0.0, t;
    
    
    int iter=0;
    //initialize mu and update of mu
    for (int xa=0; xa<XA; xa++){
            mu0[xa]=0.0;
            mu1[xa]=0.0;
    }//close xa
    
    
    
    //initialize   zero assets for all
    // x following ss distribution of x ; 
        for (int x=0; x<sizeofXgrid;x++){
            mu0[0+sizeofAssetgrid*x]= x_ss[x]; 
    	}
    
    
    t=omp_get_wtime();
    double temp=0;
    int savind=0;
    while( iter< distribution_maxiter){
      
			
			for(int xa=0;xa<XA;xa++){
					int a=aind[xa];
					int x=xind[xa];
					int offset=x*sizeofAssetgrid;
					int savind=savings_index[xa];
					Fmu[offset+savind]+= mu0[xa];
				}//xa				
				
				
			
			
			
				#pragma omp parallel for schedule( static,1 )
				for(int xa=0;xa<XA;xa++){
                   int xpr= xind[xa]; 
                   int apr=aind[xa];
                   int offset=xpr*sizeofXgrid;
                   
                    for(int x=0;x<sizeofXgrid;x++){
						mu1[xa]+=Fmu[sizeofAssetgrid*x+apr]*Xprobtranflat[offset+x];
						}//xpr
        			}//xa


		
        /*
		error=0.0;
		///compute error and update
        for (int xa=0; xa<XA; xa++){
                errortemp=fabs(mu1[xa]-mu0[xa]);
                mu0[xa]=mu1[xa];
                mu1[xa]=0.0;
                Fmu[xa]=0.0;
                if (errortemp> error){
					 error=errortemp;
                }//close if
        }//close ex
        */
    		error=0.0;
	#pragma omp parallel for reduction(max : error)
    for( int xa=0;xa<XA; xa++){
       		double etemp=fabs(mu1[xa]-mu0[xa]);
      		mu0[xa]=mu1[xa];
      		mu1[xa]=0.0;
      		Fmu[xa]=0.0; 
        if(etemp > error){
            error = etemp;   
        }//if
     }//for
    
        
        
        
        /*
        if(iter%100==0){
            cout<<error<<endl;
        }
        */
        iter++;
        
        if (error<distribution_toler){
            cout<<" invariant distribution over (A x X) found in "<< iter<<" iterations \n";
            
            iter=distribution_maxiter;
        }
        else if (iter==distribution_maxiter){
            cout<<"distribution did not converge, increase allowed iterations or check policies "<<endl;
            cout<<"error is "<< error<<endl;
        }
        
        
        
        
    }//close while loop
    
	cout<<" invariant distribution over (A x X) found in "<< omp_get_wtime()-t<<" seconds \n";
    
    
    //calculate cumulative measure over BxAxX
    for(int x=0; x<sizeofXgrid;x++){
        CDF_mu0[x][0]=mu0[x*sizeofAssetgrid ];
        for(int a=1; a<sizeofAssetgrid;a++){
            CDF_mu0[x][a] = CDF_mu0[x][a-1] + mu0[x*sizeofAssetgrid+a]; 
        }
        
        if(x>=1){
            for(int a=0; a<sizeofAssetgrid;a++){
                CDF_mu0[x][a] = CDF_mu0[x][a] + CDF_mu0[x-1][a];
            }//close a
        }//close if x>=1
    }//close x
    
    
    
    
    
    return;
    
}//close get_invariant_distribution

double Vss::get_implied_r(){
    double r_new=0.0,out;
    Agg_K=0.0;
    Agg_L=0.0;
    
    
    int offset=0;
    int x,a;
    for (int xa=0; xa<XA; xa++){
    	a=aind[xa];
    	x=xind[xa];
            Agg_K += mu0[xa]*Assetgrid[a];
            Agg_L += exp(Xgrid[x])*mu0[xa];

    }//close xa
    
    r_new = 1.0*alpha*pow(Agg_K/Agg_L,alpha-1.00)-delta ;
    
    
    double lnKLold= ( log(r+delta) -log(alpha)  )/(alpha-1);
    cout<<" K/L  demanded "<< exp(lnKLold)<<endl;
    cout<<" K/L supplied "<< Agg_K/Agg_L<<endl;
    
    cout<<"interest rate (net of depreciation) associated with  beta "<< beta <<"  is "<< r_new <<endl;	

	out=r_new-r;
	return out;
	
}//get r



void locate(double xx[], int n, double x, int *j)
{
	int ju,jm,jl;
	int ascnd;
	
	jl=0;
	ju=n+1;
	ascnd=(xx[n] >= xx[1]);
	while (ju-jl > 1) {
		jm=(ju+jl) >> 1;
		if (x >= xx[jm] == ascnd)
			jl=jm;
		else
			ju=jm;
	}
	if (x == xx[1]) *j=1;
	else if(x == xx[n]) *j=n-1;
	else *j=jl;
}




double  cdf_normal( double x){
	return  0.5*erfc(-x/sqrt(2));
}

double max( double a[], int arraysize, int &maxindex){
	double maxer=a[0];
	maxindex=0;
	for (int i=1; i<arraysize; i++){
		if  (a[i]>maxer){
	        maxer=a[i];
			maxindex=i;
		}//close if
	}//close for
	
	return maxer;
} //close max

double max( double a, double b, int &maxer){
	if (a > b){
		maxer=0;
		return a;
	}
	else{
		maxer=1;
		return b;
		
	}
	
	
}//close max

double max(double a, double b){
	if (a >= b){
		return a;
	}
	else{
		return b;
	}
}

double max( double a[],int arraysize){
	double maxer=a[0];
	for (int i=1; i<arraysize; i++){
		if  (a[i]>maxer){
	        maxer=a[i];
		}//close if
	}//close for
	return maxer;
}


double min(double a, double b){
	if (a >= b){
		return b;
	}
	else{
		return a;
	}
}


int max(int a, int b){
	if (a >= b){
		return a;
	}
	else{
		return b;
	}
}

int min(int a, int b){
	if (a >= b){
		return b;
	}
	else{
		return a;
	}
}



double linear_interp( double x[], double y[], int nn, double xtilde){
	int i=0;
	double slope=0;
	
	//while( xtilde>x[i]){ i++;}
	locate(x-1,nn,xtilde, &i);
	i=i-1;
	
	if (i>=nn-1){ i=nn-2;}//incase of extrapolation beyond upper bound
	if(i<0){ i=0;}//incase of extrapolation beyond lower bound
	if ( fabs(xtilde-x[i])<1e-6){ return y[i];}
	if ( fabs(xtilde-x[i+1])<1e-6){ return y[i+1];}
	
	else{
		//	//know that  x[i]<   xtilde < x[i+1]
		
		//	//fit slope
		slope=( y[i+1]- y[i] )/(x[i+1]-x[i]);
		
		return y[i] +(xtilde-x[i])*slope;
	}
	return 0;
}//close linear_interp

double linear_interp( double x[], int y[], int nn, double xtilde){
    
    //note here the y is really an index vector
    //i.e. this is specifically designed for the case where y is an index for elements in x
	int i=0;
	double slope=0;
	
	//while( xtilde>x[i]){ i++;}
	locate(x-1,nn,xtilde, &i);
	i=i-1;
	
	if (i>=nn-1){ i=nn-2;}//incase of extrapolation beyond upper bound
	if(i<0){ i=0;}//incase of extrapolation beyond lower bound
	if ( fabs(xtilde-x[i])<1e-6){ return x[y[i]];}
	if ( fabs(xtilde-x[i+1])<1e-6){ return x[y[i+1]];}
	
	else{
		//	//know that  x[i]<   xtilde < x[i+1]
		
		//	//fit slope
		slope=( x[y[i+1]]- x[y[i]] )/(x[i+1]-x[i]);
		
		return x[y[i]] +(xtilde-x[i])*slope;
	}
	return 0;
}//close linear_interp
/*
 double linear_interp2( double x[], double y[], int nn, double xtilde){
 //takes unit offset arrays
 
 int i=1;
 double slope=0;
 while( xtilde>x[i]){ i++;}
 
 if (i>=nn){ i=nn;}//incase of extrapolation 
 if(i==1){ i=2;}//incase of extrapolation beyond lower bound
 
 if ( fabs(xtilde-x[i])<1e-4){ return y[i];}
 if ( fabs(xtilde-x[i-1])<1e-4){ return y[i-1];}
 
 else{
 //	//know that  x[i-1]<   xtilde < x[i]
 
 //	//fit slope
 slope=( y[i]- y[i-1] )/(x[i]-x[i-1]);
 
 return y[i-1] +(xtilde-x[i-1])*slope;
 }
 return 0;
 }//close linear_interp
 */



void hpsort(unsigned long n, double ra[])
{
	unsigned long i,ir,j,l;
	double rra;
	
	if (n < 2) return;
	l=(n >> 1)+1;
	ir=n;
	for (;;) {
		if (l > 1) {
			rra=ra[--l];
		} else {
			rra=ra[ir];
			ra[ir]=ra[1];
			if (--ir == 1) {
				ra[1]=rra;
				break;
			}
		}
		i=l;
		j=l+l;
		while (j <= ir) {
			if (j < ir && ra[j] < ra[j+1]) j++;
			if (rra < ra[j]) {
				ra[i]=ra[j];
				i=j;
				j <<= 1;
			} else break;
		}
		ra[i]=rra;
	}
}




#define NR_END 1
#define FREE_ARG char*


void nrerror(char error_text[])
{
	fprintf(stderr,"Numerical Recipes run-time error...\n");
	fprintf(stderr,"%s\n",error_text);
	fprintf(stderr,"...now exiting to system...\n");
	exit(1);
}


double *dvector(long nl, long nh)
{
	double *v;
	
	v=(double *)malloc((size_t) ((nh-nl+1+NR_END)*sizeof(double)));
	if (!v) nrerror("allocation failure in dvector()");
	return v-nl+NR_END;
}


double **dmatrix(long nrl, long nrh, long ncl, long nch)
{
	long i, nrow=nrh-nrl+1,ncol=nch-ncl+1;
	double **m;
	
	m=(double **) malloc((size_t)((nrow+NR_END)*sizeof(double*)));
	if (!m) nrerror("allocation failure 1 in matrix()");
	m += NR_END;
	m -= nrl;
	
	m[nrl]=(double *) malloc((size_t)((nrow*ncol+NR_END)*sizeof(double)));
	if (!m[nrl]) nrerror("allocation failure 2 in matrix()");
	m[nrl] += NR_END;
	m[nrl] -= ncl;
	
	for(i=nrl+1;i<=nrh;i++) m[i]=m[i-1]+ncol;
	
	return m;
}

void free_dmatrix(double **m, long nrl, long nrh, long ncl, long nch)
{
	free((FREE_ARG) (m[nrl]+ncl-NR_END));
	free((FREE_ARG) (m+nrl-NR_END));
}


void free_dvector(double *v, long nl, long nh)
{
	free((FREE_ARG) (v+nl-NR_END));
}


void print_matrix( char* desc, int m, int n, double* a, int lda ) {
	int i, j;
	cout << setiosflags(ios::fixed)
	<<  setiosflags(ios::showpoint)
	<< setprecision(5);
	printf( "\n %s\n", desc );
	for( i = 0; i < m; i++ ) {
		for( j = 0; j < n; j++ ) cout<< a[i+j*lda] ;
		printf( "\n" );
	}
}


void  spline(double x[], double y[], int nn, double yp1, double ypn, double y2[])
{
	int i,k;
	double pp,qn,sig,un ,*u;
	/*
    double *uu=new double[nn];
	double *u;
	
	u=uu-1;
	*/
    u=dvector(1,nn-1);
	
	if (yp1 > 0.99e30){
		y2[1]=0.0;
		u[1]=0.0;}
	else {
		y2[1] = -0.5;
		u[1]=(3.0/(x[2]-x[1]))*((y[2]-y[1])/(x[2]-x[1])-yp1);
	}
	for (i=2;i<=nn-1;i++) {
		sig=(x[i]-x[i-1])/(x[i+1]-x[i-1]);
		pp=sig*y2[i-1]+2.0;
		y2[i]=(sig-1.0)/pp;
		u[i]=(y[i+1]-y[i])/(x[i+1]-x[i]) - (y[i]-y[i-1])/(x[i]-x[i-1]);
		u[i]=(6.0*u[i]/(x[i+1]-x[i-1])-sig*u[i-1])/pp;
	}
	if (ypn > 0.99e30)
		qn=un=0.0;
	else {
		qn=0.5;
		un=(3.0/(x[nn]-x[nn-1]))*(ypn-(y[nn]-y[nn-1])/(x[nn]-x[nn-1]));
	}
	y2[nn]=(un-qn*u[nn-1])/(qn*y2[nn-1]+1.0);
	for (k=nn-1;k>=1;k--)
		y2[k]=y2[k]*y2[k+1]+u[k];
		free_dvector(u,1,nn-1);
	//delete uu;
	return;
	
}




double splint(double xa[], double ya[], double y2a[], int nn, double x)
{
	double y=0.0;
	int klo,khi,k;
	double h,b,a;
	
	klo=1;
	khi=nn;
	
	while (khi-klo > 1) {
		k=(khi+klo) >> 1;
		if (xa[k] > x) khi=k;
		else klo=k;
	}
	
	h=xa[khi]-xa[klo];
	if (h == 0.0) cout<<("Bad xa input to routine splint \n");
	a=(xa[khi]-x)/h;
	b=(x-xa[klo])/h;
	y=a*ya[klo]+b*ya[khi]+((a*a*a-a)*y2a[klo]+(b*b*b-b)*y2a[khi])*(h*h)/6.0;
	return y;
}



